package goap

type DevicesData struct {
	FullIdType
}

func (actor *DevicesData) GetSelfOrBase() (BaseApChain, bool) {
	return actor.FullIdType.GetSelfOrBase()
}

func (actor *DevicesData) MarshalToMap() map[string]any {
	return actor.FullIdType.MarshalToMapWithName(KEY_MASTO_DEVICES)
}

type DiscoverableData struct {
	Next  BaseApChain
	Value ValueValue[bool]
}

func (namedata *DiscoverableData) GetSelfOrBase() (BaseApChain, bool) {
	return namedata.Next, true
}

func (namedata *DiscoverableData) MarshalToMap() map[string]any {
	return appendWithKey(
		namedata.Next.MarshalToMap(),
		KEY_MASTO_DISCOVERABLE,
		[]map[string]any{namedata.Value.Marshal()},
	)
}

type FeaturedData struct {
	FullIdType
}

func (actor *FeaturedData) GetSelfOrBase() (BaseApChain, bool) {
	return actor.FullIdType.GetSelfOrBase()
}

func (actor *FeaturedData) MarshalToMap() map[string]any {
	return actor.FullIdType.MarshalToMapWithName(KEY_MASTO_FEATURED)
}

type FeaturedTagsData struct {
	FullIdType
}

func (actor *FeaturedTagsData) GetSelfOrBase() (BaseApChain, bool) {
	return actor.FullIdType.GetSelfOrBase()
}

func (actor *FeaturedTagsData) MarshalToMap() map[string]any {
	return actor.FullIdType.MarshalToMapWithName(KEY_MASTO_FEATURED_TAGS)
}

type IndexableData struct {
	Next  BaseApChain
	Value ValueValue[bool]
}

func (namedata *IndexableData) GetSelfOrBase() (BaseApChain, bool) {
	return namedata.Next, true
}

func (namedata *IndexableData) MarshalToMap() map[string]any {
	return appendWithKey(
		namedata.Next.MarshalToMap(),
		KEY_MASTO_INDEXABLE,
		[]map[string]any{namedata.Value.Marshal()},
	)
}

type MemorialData struct {
	Next  BaseApChain
	Value ValueValue[bool]
}

func (namedata *MemorialData) GetSelfOrBase() (BaseApChain, bool) {
	return namedata.Next, true
}

func (namedata *MemorialData) MarshalToMap() map[string]any {
	return appendWithKey(
		namedata.Next.MarshalToMap(),
		KEY_MASTO_MEMORIAL,
		[]map[string]any{namedata.Value.Marshal()},
	)
}
